/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables.records;


import de.ship.db.tables.TCoreValuelist;

import java.time.LocalDateTime;

import org.jooq.JSONB;
import org.jooq.Record1;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreValuelistRecord extends UpdatableRecordImpl<TCoreValuelistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>common_dd.t_core_valuelist.lastchange</code>.
     */
    public void setLastchange(LocalDateTime value) {
        set(0, value);
    }

    /**
     * Getter for <code>common_dd.t_core_valuelist.lastchange</code>.
     */
    public LocalDateTime getLastchange() {
        return (LocalDateTime) get(0);
    }

    /**
     * Setter for <code>common_dd.t_core_valuelist.valuelist</code>.
     */
    public void setValuelist(Integer value) {
        set(1, value);
    }

    /**
     * Getter for <code>common_dd.t_core_valuelist.valuelist</code>.
     */
    public Integer getValuelist() {
        return (Integer) get(1);
    }

    /**
     * Setter for <code>common_dd.t_core_valuelist.values</code>. list of values
     */
    public void setValues(JSONB value) {
        set(2, value);
    }

    /**
     * Getter for <code>common_dd.t_core_valuelist.values</code>. list of values
     */
    public JSONB getValues() {
        return (JSONB) get(2);
    }

    /**
     * Setter for <code>common_dd.t_core_valuelist.fk_valuetype</code>. type of
     * values structure
     */
    public void setFkValuetype(Integer value) {
        set(3, value);
    }

    /**
     * Getter for <code>common_dd.t_core_valuelist.fk_valuetype</code>. type of
     * values structure
     */
    public Integer getFkValuetype() {
        return (Integer) get(3);
    }

    /**
     * Setter for <code>common_dd.t_core_valuelist.globallist</code>. is global
     * list
     */
    public void setGloballist(Boolean value) {
        set(4, value);
    }

    /**
     * Getter for <code>common_dd.t_core_valuelist.globallist</code>. is global
     * list
     */
    public Boolean getGloballist() {
        return (Boolean) get(4);
    }

    /**
     * Setter for <code>common_dd.t_core_valuelist.changeable</code>. allow
     * changes
     */
    public void setChangeable(Boolean value) {
        set(5, value);
    }

    /**
     * Getter for <code>common_dd.t_core_valuelist.changeable</code>. allow
     * changes
     */
    public Boolean getChangeable() {
        return (Boolean) get(5);
    }

    /**
     * Setter for <code>common_dd.t_core_valuelist.origin</code>.
     */
    public void setOrigin(JSONB value) {
        set(6, value);
    }

    /**
     * Getter for <code>common_dd.t_core_valuelist.origin</code>.
     */
    public JSONB getOrigin() {
        return (JSONB) get(6);
    }

    /**
     * Setter for <code>common_dd.t_core_valuelist.name</code>.
     */
    public void setName(String value) {
        set(7, value);
    }

    /**
     * Getter for <code>common_dd.t_core_valuelist.name</code>.
     */
    public String getName() {
        return (String) get(7);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TCoreValuelistRecord
     */
    public TCoreValuelistRecord() {
        super(TCoreValuelist.T_CORE_VALUELIST);
    }

    /**
     * Create a detached, initialised TCoreValuelistRecord
     */
    public TCoreValuelistRecord(LocalDateTime lastchange, Integer valuelist, JSONB values, Integer fkValuetype, Boolean globallist, Boolean changeable, JSONB origin, String name) {
        super(TCoreValuelist.T_CORE_VALUELIST);

        setLastchange(lastchange);
        setValuelist(valuelist);
        setValues(values);
        setFkValuetype(fkValuetype);
        setGloballist(globallist);
        setChangeable(changeable);
        setOrigin(origin);
        setName(name);
        resetChangedOnNotNull();
    }
}
